VERSION 5.00
Begin VB.UserControl VbTalkSample 
   BackColor       =   &H00FFFFFF&
   ClientHeight    =   1200
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6345
   ScaleHeight     =   1200
   ScaleWidth      =   6345
   Begin VB.CommandButton btnPublish 
      Caption         =   "Publish"
      Height          =   375
      Left            =   4800
      TabIndex        =   2
      Top             =   720
      Width           =   1455
   End
   Begin VB.TextBox txtMsg 
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   4575
   End
   Begin VB.Label lblMsg 
      BackColor       =   &H00FFFFFF&
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6135
   End
End
Attribute VB_Name = "VbTalkSample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Dim arrMsg() As String
Dim arrMsgType() As String

Private Sub btnPublish_Click()
    Call publishMessage("vbsamp", txtMsg.Text)
End Sub

Public Function acceptMsg(sMsgType As String, sMsg As String)
    lblMsg.Caption = "MsgType: " + sMsgType + " Msg: " + sMsg
End Function

Public Function getNumMessages() As Integer
    getNumMessages = UBound(arrMsg)
End Function

Public Function getMsgType(iMsgIndex As Integer) As String
    getMsgType = arrMsgType(iMsgIndex)
End Function

Public Function getMsg(iMsgIndex As Integer) As String
    getMsg = arrMsg(iMsgIndex)
End Function

Public Function flushMsg(iMsgIndex As Integer)
    Dim iIndex As Integer

    For iIndex = iMsgIndex To UBound(arrMsg) - 1
        arrMsg(iIndex) = arrMsg(iIndex + 1)
        arrMsgType(iIndex) = arrMsgType(iIndex + 1)
    Next iIndex
    ReDim Preserve arrMsg(0 To UBound(arrMsg) - 1)
    ReDim Preserve arrMsgType(0 To UBound(arrMsgType) - 1)
End Function

Public Function publishMessage(sMsgType As String, sMsg As String)
    ReDim Preserve arrMsg(0 To (UBound(arrMsg) + 1))
    ReDim Preserve arrMsgType(0 To (UBound(arrMsgType) + 1))
    arrMsg(UBound(arrMsg) - 1) = sMsg
    arrMsgType(UBound(arrMsgType) - 1) = sMsgType
End Function

Private Sub UserControl_Initialize()
    ReDim Preserve arrMsg(0 To 0)
    ReDim Preserve arrMsgType(0 To 0)
End Sub
